.TH MOO 1 "April 12 1994" "Stanford University" "SUIF Compiler"
.SH NAME
moo \- analyze SUIF program for privatizable scalar variables.
.SH SYNOPSIS
.B moo
.B -Psce
.I infile
.I outfile
.SH DESCRIPTION
The
.I moo
program reads in a SUIF file one procedure at a time, attaching to
each for-loop an annotation that indicates the privatizable scalar variables
of the loop.  A variable is privatizable if every iteration of the for-loop
can have its own copy of the variable.
The annotated SUIF program is written out into
.IR outfile .
.PP
.I Moo
considers a scalar variable as privatizable if the variable is
read or written in the loop and there are no upward exposed read of
the variable at the entry of the loop body, and if no definition
of the variable in the loop reaches a use outside of the loop.
For example, in the following program fragment:
.LP
.nf
.ft B
	do 100 i=1,10
	p = f(np)
100	np = g(p)
.ft
.fi
.PP
the variable
.I p
is privatizable while the variable
.I np
is not.  In the SUIF excerpt from moo's output of the above fragment,
there are three kinds of annotations: one indicates that i, np, and p
are read in the loop, one indicates that  i, np, and p are written,
and one that indicates i, and p are privatizable.
.LP
.nf
.ft B
   2: FOR (Index=MAIN__.i Test=SLTE Cont=L:MAIN__.L1 Brk=L:MAIN__.L2)
      ["read vars": <MAIN__.i,0> <MAIN__.np,0> <MAIN__.p,0>]
      ["write vars": <MAIN__.i,0> <MAIN__.np,0> <MAIN__.p,0>]
      ["privatizable": <MAIN__.i,0> <MAIN__.p,0>]
.ft
.fi
.SH OPTIONS
.I Moo
accepts exactly one flag
.BR -Psce .
Every time you invoke
.IR moo ,
you must include this flag.
.I Moo
has been designed to serve as the basis for a new scalar optimizer to replace
oynk.  If and when that happens,
.I moo
will accept other flags.
.SH SEE ALSO
oynk(1)
	
